#!/bin/bash
LDAPPASS="$(mktemp /tmp/llxcfg-ldap-server_XXXXXX)"
if [ -e "/etc/lliurex-cap-secrets/ldap-master/ldap.secret" ] ; then
        echo -n "$(cat /etc/lliurex-cap-secrets/ldap-master/ldap.secret)" > $LDAPPASS
else
        echo -n "$(cat /etc/lliurex-secrets/passgen/ldap.secret)" > $LDAPPASS
fi
eval "$(llxcfg-showvars LDAP_BASE_DN)"
ADMINDN="cn=admin,$LDAP_BASE_DN"
ldapsearch -x "(cn=flux)" member | grep -q "calipo"
rc="$?"
if [ "$rc" = "0" ]; then
        #Calipo founded
        AUXFILE="$(mktemp /tmp/llxcfg-ldap-server_XXXXXX)"
        llxcfg-template /usr/share/llxcfg-ldap/ldiffrozenuser.ldif > $AUXFILE
        ldapmodify -D "$ADMINDN" -y "$LDAPPASS" -f "$AUXFILE"
fi

ldapsearch -x "(cn=freeze)" dn | grep -q "^dn"
rc="$?"
if [ "$rc" = "0" ]; then
        #freeze not founded
        AUXFILE="$(mktemp /tmp/llxcfg-ldap-server_XXXXXX)"
        llxcfg-template /usr/share/llxcfg-ldap/ldiffreezegroup.ldif > $AUXFILE
        ldapadd -D "$ADMINDN" -y "$LDAPPASS" -f "$AUXFILE"
fi

ldapsearch -x "(cn=calipro)" dn | grep -q "^dn"
rc="$?"
if [ "$rc" = "0" ]; then
        #calipro not founded
        AUXFILE="$(mktemp /tmp/llxcfg-ldap-server_XXXXXX)"
        llxcfg-template /usr/share/llxcfg-ldap/ldifcaliprogroup.ldif > $AUXFILE
        ldapadd -D "$ADMINDN" -w "$LDAPPASS" -f "$AUXFILE"
fi
rm -f $LDAPPASS

